﻿# -*- coding: utf-8 -*-

#エッジパラレル選択（追加型）
#他ソフトのリング選択ツールみたいなもの
#最後に選択したエッジから探索を開始し、パラレルエッジを追加します
#SHIFTキーを押しながらエッジを選択してからこのスクリプトを実行すると選択辺をどんどん追加していけます
#追加選択したくない場合はSHIFTキーを押さないでエッジを一つだけ選択してからスクリプトを実行してください
#内容大幅見直し版（2010.01.29） 

#片面表示の際に面の向きが統一されていないような形状で使用すると落ちるバグを修正


#動作条件
#選択形状がポリゴンメッシュ
#編集モードに入っている
#辺編集モード
#辺が一つ以上選択されている


def return_henlist(face):
  #面番号から面を構成する辺の番号を返す
  #前後にsetup_winged_edgeとclean_winged_edgeが必要

  tempvlist=xshade.scene().active_shape().face(face).vertex_indices

  henlist=[]
  for i in tempvlist:
    tempf=xshade.scene().active_shape().eccwfv(face,i,False)
    henlist.append(tempf)

  return henlist


def ring_sel(ashpe,tuikalist,imaedge,face):
  startedge=imaedge
  while True:
    #面から面を構成する辺のリストを作る
    henlist=return_henlist(face)
    if len(henlist)==4:
      vlist=list(ashape.face(face).vertex_indices)
      vv0=ashape.edge(imaedge).v0
      vv1=ashape.edge(imaedge).v1
#      print vlist
      vlist.remove(vv0)
      vlist.remove(vv1)
      #残った頂点二個から辺の番号を取得
      for i in henlist:
#        print ashape.edge(i).v0,ashape.edge(i).v1
        if ashape.edge(i).v0==vlist[0] and ashape.edge(i).v1==vlist[1]:temp1=i
        if ashape.edge(i).v1==vlist[0] and ashape.edge(i).v0==vlist[1]:temp1=i

      if temp1==startedge:return True
      else:
        imaedge=temp1
        tuikalist.append(imaedge)
        tflist=[]
        tempface=ashape.fccwev(imaedge,vlist[0],False)
        if tempface>=0:tflist.append(tempface)
        tempface=ashape.fcwev(imaedge,vlist[0],False)
        if tempface>=0:tflist.append(tempface)
        tflist.remove(face)
        if len(tflist)>0:
          face=tflist[0]
        else:return False

    else:return False





dousasuru=0

xscene=xshade.scene()
ashape=xshade.scene().active_shape()

if ashape.type==7 and xscene.is_modify_mode==True and xscene.selection_mode==1:
  edgelist=[]
  for i in range(ashape.number_of_edges):
    if ashape.edge(i).active==True:
      edgelist.append(i)

  if len(edgelist)>0:dousasuru=1


if dousasuru==1:


  #面の向きを統一
  ashape.adjust_face_direction()

  #一番最後に選択に追加された辺を探す
  sedge=-1
  aorder=-1
  for i in edgelist:
    if ashape.edge(i).active_order>aorder:
      aorder=ashape.edge(i).active_order
      sedge=i

  #辺の両端の面リストを作る

  ashape.setup_winged_edge()  #最後らへんでcleanし忘れないように

  ev0=ashape.edge(sedge).v0
  ev1=ashape.edge(sedge).v1
  face1=ashape.fccwev(sedge,ev0,False)
  face2=ashape.fcwev(sedge,ev0,False)
  facelist=[]
  if face1>=0:facelist.append(face1)
  if face2>=0:facelist.append(face2)

  if face1<0 and face2<0: #隣接面無し
    dousasuru=0
    ashape.clean_winged_edge()
 
if dousasuru==1:

  xscene.inhibit_update()
  tuikalist=[]

  #隣接面の数でパターンをちょっと変える
  if len(facelist)>1:
    if ring_sel(ashape,tuikalist,sedge,face1)!=True:
      ring_sel(ashape,tuikalist,sedge,face2)

  else:
    ring_sel(ashape,tuikalist,sedge,facelist[0])


  ashape.clean_winged_edge()  

  #辺を選択に追加
  for i in tuikalist:
    ashape.edge(i).active=True


  xscene.allow_update()



